Index: branches/encoders/code/projects/libwireless/lib/wl_token_ring.c
===================================================================
--- branches/encoders/code/projects/libwireless/lib/wl_token_ring.c	(revision 1344)
+++ branches/encoders/code/projects/libwireless/lib/wl_token_ring.c	(revision 1345)
@@ -645,169 +856,15 @@
  *
  * @param source the robot who accepted us
  **/
-void wl_token_join_accept_receive(int source)
+static void wl_token_join_accept_receive(int source)
 {
 	WL_DEBUG_PRINT("Accepted into the token ring by robot ");
 	WL_DEBUG_PRINT_INT(source);
 	WL_DEBUG_PRINT(".\r\n");
-	joinDelay = -1;
+	joinDelay = JOIN_DELAY;
 	ringState = ACCEPTED;
 	acceptor = source;
 
 	//add ourselves to the token ring
-	sensor_matrix_set_in_ring(sensorMatrix, wl_get_xbee_id(), 1);
+	sensor_matrix_set_in_ring(wl_get_xbee_id(), 1);
 }
-
-/**
- * Called when we receive a packet passing the token and interrupting
- * the token ring.
- * If the token has been passed to us, we flash our BOM
- * and pass it back.
- *
- * @param source the robot who sent the interrupt packet
- * @param robot the robot the token has been passed to
- **/
-void wl_token_interrupt_pass_receive(int source, int robot)
-{
-	if (wl_get_xbee_id() != robot)
-	{
-		queue_remove_all(interrupting, (void*)robot);
-		wl_token_next_robot = robot;
-		deathDelay = DEATH_DELAY + rand() / (RAND_MAX / (2 * DEATH_DELAY));
-		return;
-	}
-	wl_send_global_packet(WL_TOKEN_RING_GROUP, WL_TOKEN_BOM_ON,
-		NULL, 0, 0);
-	
-	bom_on_function();
-	#ifdef ROBOT
-	delay_ms(BOM_DELAY);
-	#endif
-	bom_off_function();
-
-	//we don't include ourself, only if we are in the ring
-	int packetSize = 1 + 2 * (sensor_matrix_get_joined(sensorMatrix) - 1);
-	if (!sensor_matrix_get_in_ring(sensorMatrix, wl_get_xbee_id()))
-		packetSize += 2;
-	char* buf = (char*)malloc(packetSize * sizeof(char));
-	if (!buf)
-	{
-		WL_DEBUG_PRINT("Out of memory - pass_receive.\r\n");
-		return;
-	}
-	
-	//return the token to where we got it from
-	buf[0] = source;
-
-	int i = 0, j = 0;
-	for (i = 0; i < sensor_matrix_get_size(sensorMatrix); i++)
-		if (sensor_matrix_get_in_ring(sensorMatrix, i) && i != wl_get_xbee_id())
-		{
-			buf[2*j + 1] = i;
-			buf[2*j + 2] = sensor_matrix_get_reading(sensorMatrix, wl_get_xbee_id(), i);
-			j++;
-		}
-	
-	wl_send_global_packet(WL_TOKEN_RING_GROUP, WL_TOKEN_PASS,
-		buf, packetSize, 0);
-
-	wl_token_next_robot = source;
-	deathDelay = DEATH_DELAY;
-	free(buf);
-}
-
-/**
- * Returns the number of robots in the token ring.
- *
- * @return the number of robots in the token ring
- **/
-int wl_token_get_robots_in_ring(void)
-{
-	return sensor_matrix_get_joined(sensorMatrix);
-}
-
-/**
- * Returns true if the specified robot is in the token ring, false
- * otherwise.
- *
- * @param robot the robot to check for whether it is in the token ring
- * @return nonzero if the robot is in the token ring, zero otherwise
- **/
-int wl_token_is_robot_in_ring(int robot)
-{
-	return sensor_matrix_get_in_ring(sensorMatrix, robot);
-}
-
-/**
- * Begins iterating through the robots in the token ring.
- *
- * @see wl_token_iterator_has_next, wl_token_iterator_next
- **/
-void wl_token_iterator_begin(void)
-{
-	int i = 0;
-	iteratorCount = 0;
-	while (!sensor_matrix_get_in_ring(sensorMatrix, i) &&
-			i < sensor_matrix_get_size(sensorMatrix))
-		i++;
-	if (i == sensor_matrix_get_size(sensorMatrix))
-		i = -1;
-}
-
-/**
- * Returns true if there are more robots in the token ring
- * to iterate through, and false otherwise.
- *
- * @return nonzero if there are more robots to iterate through,
- * zero otherwise
- *
- * @see wl_token_iterator_begin, wl_token_iterator_next
- **/
-int wl_token_iterator_has_next(void)
-{
-	return iteratorCount == -1;
-}
-
-/**
- * Returns the next robot ID in the token ring.
- *
- * @return the next robot ID in the token ring, or -1 if none exists
- *
- * @see wl_token_iterator_begin, wl_token_iterator_has_next
- **/
-int wl_token_iterator_next(void)
-{
-	int result = iteratorCount;
-	if (result < 0)
-		return result;
-
-	iteratorCount++;
-	while (!sensor_matrix_get_in_ring(sensorMatrix, iteratorCount) &&
-		iteratorCount < sensor_matrix_get_size(sensorMatrix))
-		iteratorCount++;
-	if (iteratorCount == sensor_matrix_get_size(sensorMatrix))
-		iteratorCount = -1;
-	return result;
-}
-
-/**
- * Called when we receive a request to interrupt the token ring.
- * We add the robot to our list of interrupt requests,
- * and will send the token to this robot when we next receive the
- * token, unless someone else does so first.
- *
- * @param source the robot requesting interruption
- * @param robt the robot requested to interrupt the token ring
- **/
-void wl_token_interrupt_request_receive(int source, int robot)
-{
-	queue_add(interrupting, (void*)robot);
-}
-
-int wl_token_get_num_robots(void){
-  return sensor_matrix_get_joined(sensorMatrix);
-}
-
-int wl_token_get_matrix_size(void){
-  return sensor_matrix_get_size(sensorMatrix);
-}
Index: branches/encoders/code/projects/libwireless/lib/sensor_matrix.h
===================================================================
--- branches/encoders/code/projects/libwireless/lib/sensor_matrix.h	(revision 1344)
+++ branches/encoders/code/projects/libwireless/lib/sensor_matrix.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file sensor_matrix.h
  * @brief Definitions for sensor matrices
  *
@@ -7,6 +32,10 @@
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
 
+#ifndef SENSOR_MATRIX_H
+#define SENSOR_MATRIX_H
+
+
 /**
  * @defgroup sensormatrix Sensor Matrix
  * @brief the robot sensor matrix
@@ -17,53 +46,56 @@
  * @{
  **/
 
+#define MAXIMUM_XBEE_ID		0x10
+#define READING_UNKNOWN		0xFF
+
 /**
  * @struct SensorMatrix
  *
  * A sensor matrix.
  **/
+//TODO: the order of member variables in this struct should be changed in case the compile packs the struct
+// In order to achieve the best packing, the variables should be listed in order of decreasing memory size.
+// Thus, pointers should be first, followed by int, followed by char.
 typedef struct
 {
 	/**
-	 * The size of the sensor matrix.
-	**/
-	unsigned int size;
-	/**
-	 * The matrix. Each row represents the readings of one
-	 * robot.
+	 * The number of robots in the token ring.
 	 **/
-	int** matrix;
+	int numJoined;
 	/**
 	 * The element representing a robot is true if that robot
 	 * is in the token ring and false otherwise.
 	 **/
-	int* joined;
+	unsigned char joined[MAXIMUM_XBEE_ID];
+
+	// on the bayboard, we don't include the matrix to save memory.
+#ifndef BAYBOARD
 	/**
-	 * The number of robots in the token ring.
+	 * The matrix. Each row represents the readings of one
+	 * robot.
 	 **/
-	int numJoined;
+	unsigned char matrix[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID];
+#endif
 } SensorMatrix;
 
 /**@brief Create a sensor matrix **/
-SensorMatrix* sensor_matrix_create(void);
-/**@brief Destroy a sensor matrix **/
-void sensor_matrix_destroy(SensorMatrix* m);
-/**@brief Add a robot to a sensor matrix **/
-void sensor_matrix_add_robot(SensorMatrix* m, unsigned int id);
-/**@brief Remove a robot from a sensor matrix **/
-void sensor_matrix_remove_robot(SensorMatrix* m, unsigned int id);
+void sensor_matrix_create(void);
 /**@brief Set a reading in a sensor matrix **/
-void sensor_matrix_set_reading(SensorMatrix* m, int observer, int robot, int reading);
+void sensor_matrix_set_reading(int observer, int robot, int reading);
 /**@brief Get a reading in a sensor matrix **/
-int sensor_matrix_get_reading(SensorMatrix* m, int observer, int robot);
+int sensor_matrix_get_reading(int observer, int robot);
 /**@brief Set whether the robot is in the token ring **/
-void sensor_matrix_set_in_ring(SensorMatrix* m, int robot, int in);
+void sensor_matrix_set_in_ring(int robot, int in);
 /**@brief Get whether the robot is in the sensor ring **/
-int sensor_matrix_get_in_ring(SensorMatrix* m, int robot);
-/**@brief Get the size of the sensor matrix **/
-int sensor_matrix_get_size(SensorMatrix* m);
+int sensor_matrix_get_in_ring(int robot);
 /**@brief Get the number of robots which have joined the token ring **/
-int sensor_matrix_get_joined(SensorMatrix* m);
+int sensor_matrix_get_joined(void);
+/**@brief Get the maximum size of the sensor matrix **/
+int sensor_matrix_get_size(void);
 
 /** @} **/ //end defgroup
 
+
+#endif
+
Index: branches/encoders/code/projects/libwireless/lib/wireless.h
===================================================================
--- branches/encoders/code/projects/libwireless/lib/wireless.h	(revision 1344)
+++ branches/encoders/code/projects/libwireless/lib/wireless.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file wireless.h
  * @brief Contains definitions for the wireless library.
  *
@@ -6,12 +31,19 @@
  *
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
- 
+
+#ifndef WIRELESS_H
+#define WIRELESS_H
+
 //Note: If this is raised above 16, we will need to do
 //something about frame numbers for TX Status packets.
 /**
  * The maximum number of packet groups.
  **/
+//TODO: a PacketGroupHandler is at least 10 bytes (I don't know if function pointers are 2 bytes
+// or 4 bytes).  That means that in the c file, your array of packet groups is at least 160 bytes.
+// Normally that might be fine (the robot's avr chips have 4k SRAM), but austin's chip only has
+// 1k SRAM, so if this number can be reduced or if the size of the struct could be reduced, that would be a plus.
 #define WL_MAX_PACKET_GROUPS 16
 
 /**
@@ -20,12 +52,12 @@
  *
  * Contains functions and definitions for dealing with wireless functionality.<br><br>
  *
- * The wireless library provides a modular method for dealing with 
+ * The wireless library provides a modular method for dealing with
  * wireless packets, by allowing packet groups to be registered.
  * A packet group is a collection of packets which share a packet
- * group code. Each packet in the group also has a type. A packet 
+ * group code. Each packet in the group also has a type. A packet
  * group code and type are sent with each packet. When a packet
- * with a group code registered in the wireless library is 
+ * with a group code registered in the wireless library is
  * received, the corresponding event handler is called. The
  * event handler uses the packet type and other information
  * stored in the packet to respond.<br><br>
@@ -39,11 +71,14 @@
 
 /**
  * @struct PacketGroupHandler
- * A PacketGroupHandler represents a packet group, and is used to 
+ * A PacketGroupHandler represents a packet group, and is used to
  * register a packet group with the wireless library. It contains
  * handlers for various events which can occur related to a packet
  * group.
  **/
+//TODO: the order of member variables in this struct should be changed in case the compile packs the struct
+// In order to achieve the best packing, the variables should be listed in order of decreasing memory size.
+// Thus, pointers should be first, followed by int, followed by char.
 typedef struct
 {
 	/**
@@ -51,6 +86,8 @@
 	 * must be unique. The maximum number of packet groups
 	 * is defined by WL_MAX_PACKET_GROUPS.
 	 **/
+  //TODO: if this number must be less than or equal to WL_MAX_PACKET_GROUPS, don't you only need
+  // one byte for it and it can be made an unsigned char?
 	unsigned int groupCode;
 
 	/**
@@ -58,7 +95,7 @@
 	 * but in wl_do).
 	 **/
 	void (*timeout_handler) (void);
-	
+
 	/**
 	 * Called when a transmit status packet is received
 	 * from the XBee where the first four bits of the frame
@@ -69,7 +106,7 @@
 	 * we did not.
 	 **/
 	void (*handle_response) (int frame, int received);
-	
+
 	/**
 	 * Called when we receive a packet from this group.
 	 *
@@ -79,18 +116,17 @@
 	 * @param packet the packet received
 	 * @param length the length of the packet
 	 **/
-	void (*handle_receive) (char type, int source, unsigned char* packet,
-							int length);
-	
+	void (*handle_receive) (char type, int source, unsigned char* packet, int length);
+
 	/**
 	 * Called for any cleanup when the network is turned off.
 	 **/
 	void (*unregister) (void);
-	
+
 } PacketGroupHandler;
 
 /**@brief Initialize the wireless library **/
-void wl_init(void);
+int wl_init(void);
 /**@brief Uninitialize the wireless library **/
 void wl_terminate(void);
 /**@brief Perform wireless library functionality **/
@@ -101,28 +137,28 @@
 void wl_unregister_packet_group(PacketGroupHandler* h);
 
 /**@brief Send a packet to a specific robot in any PAN **/
-void wl_send_robot_to_robot_global_packet(char group, char type,
-		char* data, int len, int dest, char frame);
+int wl_send_robot_to_robot_global_packet(char group, char type, char* data, int len, int dest, char frame);
 /**@brief Send a packet to a specific robot in our PAN **/
-void wl_send_robot_to_robot_packet(char group, char type,
-		char* data, int len, int dest, char frame);
+int wl_send_robot_to_robot_packet(char group, char type, char* data, int len, int dest, char frame);
 /**@brief Send a packet to all robots **/
-void wl_send_global_packet(char group, char type,
-		char* data, int len, char frame);
+int wl_send_global_packet(char group, char type, char* data, int len, char frame);
 /**@brief Send a packet to all robots in our PAN **/
-void wl_send_pan_packet(char group, char type,
-		char* data, int len, char frame);
+void wl_send_pan_packet(char group, char type, char* data, int len, char frame);
 
 /**@brief Set the PAN we are using **/
-void wl_set_pan(int pan);
+int wl_set_pan(int pan);
 /**@brief Get the PAN we are using **/
 int wl_get_pan(void);
 /**@brief Set the channel we are using **/
-void wl_set_channel(int channel);
+int wl_set_channel(int channel);
 /**@brief Get the channel we are using **/
 int wl_get_channel(void);
 /**@brief Get the 16-bit address of the XBee module **/
-unsigned int wl_get_xbee_id(void);
+int wl_get_xbee_id(void);
+/**@brief Set the com port on a computer, undefined on the robot.**/
+void wl_set_com_port(char* port);
 
 /** @} **/ // end defgroup
 
+#endif
+
